theory SN_Order_Carrier2
imports SN_Order_Carrier SN_Orders2
begin

instantiation rat :: poly_carrier
begin
instance ..
end

instantiation int :: poly_carrier
begin
instance ..
end

instantiation nat :: poly_carrier
begin
instance ..
end

instantiation arctic :: max_ordered_semiring_1
begin
definition max0_arctic :: "arctic \<Rightarrow> arctic" where [simp]: "max0_arctic \<equiv> id"
instance
proof
  fix x :: arctic
  show "x \<ge> 0" by (cases x, auto simp: zero_arctic_def)
next
  fix x :: arctic
  show "max0 x \<ge> x" by (cases x, auto)
qed auto
end

instantiation arctic_rat :: max_ordered_semiring_1
begin
definition max0_arctic_rat :: "arctic_rat \<Rightarrow> arctic_rat" where [simp]: "max0_arctic_rat \<equiv> id"
instance
proof
  fix x :: arctic_rat
  show "x \<ge> 0" by (cases x, auto simp: zero_arctic_rat_def)
next
  fix x :: arctic_rat
  show "max0 x \<ge> x" by (cases x, auto)
qed auto
end

lemma rat_poly: assumes dpos: "\<delta> > 0" and default: "\<delta> \<le> def"
  shows "poly_order_carrier def (rat_gt \<delta>) (1 \<le> \<delta>) False"
  by (rule poly_order_carrier.intro, rule rat_poly[OF assms])


end